Index: boost/mpl/aux_/numeric_op.hpp
===================================================================
--- boost/mpl/aux_/numeric_op.hpp	(revision 46473)
+++ boost/mpl/aux_/numeric_op.hpp	(working copy)
@@ -287,7 +287,8 @@ BOOST_MPL_AUX_NA_SPEC2(2, AUX778076_OP_A
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
 
 #   define i_ BOOST_PP_FRAME_ITERATION(1)
 
@@ -307,5 +308,5 @@ struct AUX778076_OP_NAME<BOOST_MPL_PP_PA
 #endif
 
 #   undef i_
-
+#endif
 #endif // BOOST_PP_IS_ITERATING
Index: boost/mpl/aux_/advance_backward.hpp
===================================================================
--- boost/mpl/aux_/advance_backward.hpp	(revision 46473)
+++ boost/mpl/aux_/advance_backward.hpp	(working copy)
@@ -79,7 +79,8 @@ struct advance_backward
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
 #define i_ BOOST_PP_FRAME_ITERATION(1)
 
 template<>
@@ -108,10 +109,11 @@ struct advance_backward< BOOST_PP_FRAME_
 };
 
 #undef i_
-
+#endif
 ///// iteration, depth == 2
 
-#elif BOOST_PP_ITERATION_DEPTH() == 2
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 2
 
 #   define AUX778076_ITER_0 BOOST_PP_CAT(iter,BOOST_PP_DEC(BOOST_PP_FRAME_ITERATION(2)))
 #   define AUX778076_ITER_1 BOOST_PP_CAT(iter,BOOST_PP_FRAME_ITERATION(2))
@@ -120,5 +122,5 @@ struct advance_backward< BOOST_PP_FRAME_
         
 #   undef AUX778076_ITER_1
 #   undef AUX778076_ITER_0
-
+#endif
 #endif // BOOST_PP_IS_ITERATING
Index: boost/mpl/aux_/full_lambda.hpp
===================================================================
--- boost/mpl/aux_/full_lambda.hpp	(revision 46473)
+++ boost/mpl/aux_/full_lambda.hpp	(working copy)
@@ -227,7 +227,8 @@ BOOST_MPL_AUX_NA_SPEC2(2, 3, lambda)
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
 #define i_ BOOST_PP_FRAME_ITERATION(1)
 
 #if i_ > 0
@@ -347,4 +348,5 @@ struct lambda<
 };
 
 #undef i_
+#endif
 #endif // BOOST_PP_IS_ITERATING
Index: boost/mpl/aux_/advance_forward.hpp
===================================================================
--- boost/mpl/aux_/advance_forward.hpp	(revision 46473)
+++ boost/mpl/aux_/advance_forward.hpp	(working copy)
@@ -79,7 +79,9 @@ struct advance_forward
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
+
 #define i_ BOOST_PP_FRAME_ITERATION(1)
 
 template<>
@@ -107,10 +109,11 @@ struct advance_forward< BOOST_PP_FRAME_I
 };
 
 #undef i_
-
+#endif
 ///// iteration, depth == 2
 
-#elif BOOST_PP_ITERATION_DEPTH() == 2
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 2
 
 #   define AUX778076_ITER_0 BOOST_PP_CAT(iter,BOOST_PP_DEC(BOOST_PP_FRAME_ITERATION(2)))
 #   define AUX778076_ITER_1 BOOST_PP_CAT(iter,BOOST_PP_FRAME_ITERATION(2))
@@ -119,5 +122,5 @@ struct advance_forward< BOOST_PP_FRAME_I
         
 #   undef AUX778076_ITER_1
 #   undef AUX778076_ITER_0
-
+#endif
 #endif // BOOST_PP_IS_ITERATING
Index: boost/mpl/bind.hpp
===================================================================
--- boost/mpl/bind.hpp	(revision 46473)
+++ boost/mpl/bind.hpp	(working copy)
@@ -361,7 +361,8 @@ BOOST_MPL_AUX_TEMPLATE_ARITY_SPEC(
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
 
 #   define i_ BOOST_PP_FRAME_ITERATION(1)
 
@@ -526,9 +527,11 @@ struct bind_chooser<i_>
 
 #   undef i_
 
+#endif //BOOST_PP_ITERATION_DEPTH() == 1
 ///// iteration, depth == 2
 
-#elif BOOST_PP_ITERATION_DEPTH() == 2
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 2
 
 #   define j_ BOOST_PP_FRAME_ITERATION(2)
 #   if !defined(BOOST_MPL_CFG_NO_UNNAMED_PLACEHOLDER_SUPPORT)
@@ -543,5 +546,5 @@ struct bind_chooser<i_>
 
 #   endif
 #   undef j_
-
+#endif
 #endif // BOOST_PP_IS_ITERATING
Index: boost/mpl/apply.hpp
===================================================================
--- boost/mpl/apply.hpp	(revision 46473)
+++ boost/mpl/apply.hpp	(working copy)
@@ -135,7 +135,8 @@ struct apply
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined (BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
 
 #   define i_ BOOST_PP_FRAME_ITERATION(1)
 
@@ -222,4 +223,5 @@ struct apply_chooser<i_>
 
 #   undef i_
 
+#endif
 #endif // BOOST_PP_IS_ITERATING
Index: boost/mpl/apply_wrap.hpp
===================================================================
--- boost/mpl/apply_wrap.hpp	(revision 46473)
+++ boost/mpl/apply_wrap.hpp	(working copy)
@@ -78,7 +78,8 @@ namespace boost { namespace mpl {
 
 ///// iteration, depth == 1
 
-#elif BOOST_PP_ITERATION_DEPTH() == 1
+#elif defined(BOOST_PP_ITEARTION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 1
 
 #   define i_ BOOST_PP_FRAME_ITERATION(1)
 
@@ -168,9 +169,11 @@ struct BOOST_PP_CAT(apply_wrap,i_)<AUX77
 
 #   undef i_
 
+#endif //BOOST_PP_ITERATION_DEPTH() == 1
 ///// iteration, depth == 2
 
-#elif BOOST_PP_ITERATION_DEPTH() == 2
+#elif defined(BOOST_PP_ITERATION_DEPTH)
+#if BOOST_PP_ITERATION_DEPTH() == 2
 
 #   define j_ BOOST_PP_FRAME_ITERATION(2)
 
@@ -196,5 +199,5 @@ struct BOOST_PP_CAT(apply_wrap_impl,i_)<
 };
 
 #   undef j_
-
+#endif // BOOST_PP_ITERATION_DEPTH() == 2
 #endif // BOOST_PP_IS_ITERATING
 
